Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -1136,15 +2535,12 @@
   SUBROUTINE vm_sampling
 
-    USE arrays_3d,                                                             &
-        ONLY:  exner, pt, q, u, v, w
-
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation  
+        ONLY:  radiation
 
     USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
-    
-     IMPLICIT NONE
-      
+        ONLY:  surf_def_h,                                                     &
+               surf_lsm_h,                                                     &
+               surf_usm_h
+
      INTEGER(iwp) ::  i         !< grid index in x-direction
      INTEGER(iwp) ::  j         !< grid index in y-direction
@@ -1156,23 +2552,27 @@
      INTEGER(iwp) ::  n         !< running index over all measured variables at a station
      INTEGER(iwp) ::  nn        !< running index over the number of chemcal species
-     
+
      LOGICAL ::  match_lsm !< flag indicating natural-type surface
      LOGICAL ::  match_usm !< flag indicating urban-type surface
-!
-!--  Loop over all sites. 
+
+     REAL(wp) ::  e_s      !< saturation water vapor pressure
+     REAL(wp) ::  q_s      !< saturation mixing ratio
+     REAL(wp) ::  q_wv     !< mixing ratio
+!
+!--  Loop over all sites.
      DO  l = 1, vmea_general%nvm
 !
 !--     At the beginning, set _FillValues
         IF ( ALLOCATED( vmea(l)%measured_vars      ) )                         &
-           vmea(l)%measured_vars      = vmea(l)%fillout 
+           vmea(l)%measured_vars      = vmea(l)%fillout
         IF ( ALLOCATED( vmea(l)%measured_vars_soil ) )                         &
-           vmea(l)%measured_vars_soil = vmea(l)%fillout 
-!
-!--     Loop over all variables measured at this site.  
+           vmea(l)%measured_vars_soil = vmea(l)%fillout
+!
+!--     Loop over all variables measured at this site.
         DO  n = 1, vmea(l)%nmeas
-        
-           SELECT CASE ( TRIM( vmea(l)%measured_vars_name(n) ) )
-           
-              CASE ( 'theta' )
+
+           SELECT CASE ( TRIM( vmea(l)%var_atts(n)%name ) )
+
+              CASE ( 'theta' ) ! potential temperature
                  IF ( .NOT. neutral )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -1183,6 +2583,6 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'ta' )
+
+              CASE ( 'ta' ) ! absolute temperature
                  IF ( .NOT. neutral )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -1190,11 +2590,12 @@
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                       vmea(l)%measured_vars(m,n) = pt(k,j,i) * exner( k )
+                       vmea(l)%measured_vars(m,n) = pt(k,j,i) * exner( k )     &
+                                                  - degc_to_k
                     ENDDO
                  ENDIF
-              
+
               CASE ( 't_va' )
-                 
-              CASE ( 'hus', 'haa' )
+
+              CASE ( 'hus' ) ! mixing ratio
                  IF ( humidity )  THEN
                     DO  m = 1, vmea(l)%ns
@@ -1205,6 +2606,47 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'u', 'ua' )
+
+              CASE ( 'haa' ) ! absolute humidity
+                 IF ( humidity )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = vmea(l)%k(m)
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                       vmea(l)%measured_vars(m,n) = ( q(k,j,i)                 &
+                                                    / ( 1.0_wp - q(k,j,i) ) )  &
+                                                  * rho_air(k)
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'pwv' ) ! water vapor partial pressure
+                 IF ( humidity )  THEN
+!                     DO  m = 1, vmea(l)%ns
+!                        k = vmea(l)%k(m)
+!                        j = vmea(l)%j(m)
+!                        i = vmea(l)%i(m)
+!                        vmea(l)%measured_vars(m,n) = ( q(k,j,i)                 &
+!                                                     / ( 1.0_wp - q(k,j,i) ) )  &
+!                                                   * rho_air(k)
+!                     ENDDO
+                 ENDIF
+
+              CASE ( 'hur' ) ! relative humidity
+                 IF ( humidity )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = vmea(l)%k(m)
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+!
+!--                    Calculate actual temperature, water vapor saturation
+!--                    pressure, and based on this  the saturation mixing ratio.
+                       e_s  = magnus( exner(k) * pt(k,j,i) )
+                       q_s  = rd_d_rv * e_s / ( hyp(k) - e_s )
+                       q_wv = ( q(k,j,i) / ( 1.0_wp - q(k,j,i) ) ) * rho_air(k)
+
+                       vmea(l)%measured_vars(m,n) = q_wv / ( q_s + 1E-10_wp )
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'u', 'ua' ) ! u-component
                  DO  m = 1, vmea(l)%ns
                     k = vmea(l)%k(m)
@@ -1213,6 +2655,6 @@
                     vmea(l)%measured_vars(m,n) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
                  ENDDO
-                 
-              CASE ( 'v', 'va' )
+
+              CASE ( 'v', 'va' ) ! v-component
                  DO  m = 1, vmea(l)%ns
                     k = vmea(l)%k(m)
@@ -1221,14 +2663,14 @@
                     vmea(l)%measured_vars(m,n) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
                  ENDDO
-                 
-              CASE ( 'w' )
+
+              CASE ( 'w' ) ! w-component
                  DO  m = 1, vmea(l)%ns
-                    k = MAX ( 1, vmea(l)%k(m) )  
+                    k = MAX ( 1, vmea(l)%k(m) )
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
                     vmea(l)%measured_vars(m,n) = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
                  ENDDO
-                 
-              CASE ( 'wspeed' )
+
+              CASE ( 'wspeed' ) ! horizontal wind speed
                  DO  m = 1, vmea(l)%ns
                     k = vmea(l)%k(m)
@@ -1240,17 +2682,18 @@
                                                      )
                  ENDDO
-                 
-              CASE ( 'wdir' )
+
+              CASE ( 'wdir' ) ! wind direction
                  DO  m = 1, vmea(l)%ns
                     k = vmea(l)%k(m)
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
-                    
-                    vmea(l)%measured_vars(m,n) = ATAN2(                        &
-                                       - 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ),   &
-                                       - 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )    &
-                                                      ) * 180.0_wp / pi
+
+                    vmea(l)%measured_vars(m,n) = 180.0_wp + 180.0_wp / pi      &
+                                               * ATAN2(                        &
+                                          0.5_wp * ( v(k,j,i) + v(k,j+1,i) ),  &
+                                          0.5_wp * ( u(k,j,i) + u(k,j,i+1) )   &
+                                                      )
                  ENDDO
-                 
+
               CASE ( 'utheta' )
                  DO  m = 1, vmea(l)%ns
@@ -1262,5 +2705,5 @@
                                                    pt(k,j,i)
                  ENDDO
-                 
+
               CASE ( 'vtheta' )
                  DO  m = 1, vmea(l)%ns
@@ -1272,5 +2715,5 @@
                                                    pt(k,j,i)
                  ENDDO
-                 
+
               CASE ( 'wtheta' )
                  DO  m = 1, vmea(l)%ns
@@ -1282,5 +2725,41 @@
                                                    pt(k,j,i)
                  ENDDO
-                 
+
+              CASE ( 'uqv' )
+                 IF ( humidity )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = vmea(l)%k(m)
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
+                                                    ( u(k,j,i) + u(k,j,i+1) ) *&
+                                                      q(k,j,i)
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'vqv' )
+                 IF ( humidity )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = vmea(l)%k(m)
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
+                                                    ( v(k,j,i) + v(k,j+1,i) ) *&
+                                                      q(k,j,i)
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'wqv' )
+                 IF ( humidity )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       k = MAX ( 1, vmea(l)%k(m) )
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+                       vmea(l)%measured_vars(m,n) = 0.5_wp *                   &
+                                                    ( w(k-1,j,i) + w(k,j,i) ) *&
+                                                      q(k,j,i)
+                    ENDDO
+                 ENDIF
+
               CASE ( 'uw' )
                  DO  m = 1, vmea(l)%ns
@@ -1292,5 +2771,5 @@
                                                  ( u(k,j,i)   + u(k,j,i+1) )
                  ENDDO
-                 
+
               CASE ( 'vw' )
                  DO  m = 1, vmea(l)%ns
@@ -1302,8 +2781,8 @@
                                                  ( v(k,j,i)   + v(k,j+1,i) )
                  ENDDO
-                 
+
               CASE ( 'uv' )
                  DO  m = 1, vmea(l)%ns
-                    k = MAX ( 1, vmea(l)%k(m) )
+                    k = vmea(l)%k(m)
                     j = vmea(l)%j(m)
                     i = vmea(l)%i(m)
@@ -1313,25 +2792,29 @@
                  ENDDO
 !
-!--           List of variables may need extension.
-              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mfco', 'mfno', 'mfno2',    & 
-                     'tro3' )                     
+!--           Chemistry variables. List of variables may need extension.
+!--           Note, gas species in PALM are in ppm and no distinction is made
+!--           between mole-fraction and concentration quantities (all are
+!--           output in ppm so far).
+              CASE ( 'mcpm1', 'mcpm2p5', 'mcpm10', 'mfno', 'mfno2',            &
+                     'mcno', 'mcno2', 'tro3' )
                  IF ( air_chemistry )  THEN
 !
-!--                 First, search for the measured variable in the chem_vars 
-!--                 list, in order to get the internal name of the variable. 
+!--                 First, search for the measured variable in the chem_vars
+!--                 list, in order to get the internal name of the variable.
                     DO  nn = 1, UBOUND( chem_vars, 2 )
-                       IF ( TRIM( vmea(l)%measured_vars_name(m) ) ==           &
+                       IF ( TRIM( vmea(l)%var_atts(n)%name ) ==                &
                             TRIM( chem_vars(0,nn) ) )  ind_chem = nn
                     ENDDO
 !
-!--                 Run loop over all chemical species, if the measured 
+!--                 Run loop over all chemical species, if the measured
 !--                 variable matches the interal name, sample the variable.
-                    DO  nn = 1, nvar                    
+!--                 Note, nvar as a chemistry-module variable.
+                    DO  nn = 1, nvar
                        IF ( TRIM( chem_vars(1,ind_chem) ) ==                   &
-                            TRIM( chem_species(nn)%name ) )  THEN                            
-                          DO  m = 1, vmea(l)%ns             
+                            TRIM( chem_species(nn)%name ) )  THEN
+                          DO  m = 1, vmea(l)%ns
                              k = vmea(l)%k(m)
                              j = vmea(l)%j(m)
-                             i = vmea(l)%i(m)                    
+                             i = vmea(l)%i(m)
                              vmea(l)%measured_vars(m,n) =                      &
                                                    chem_species(nn)%conc(k,j,i)
@@ -1340,15 +2823,15 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'us' )
+
+              CASE ( 'us' ) ! friction velocity
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not 
-!--                 on ghost points. Hence, limit the indices. 
-                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                    j = MERGE( j           , nyn, j            > nyn )
-                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                    i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
@@ -1364,15 +2847,15 @@
                     ENDDO
                  ENDDO
-                 
-              CASE ( 'ts' )
+
+              CASE ( 'thetas' ) ! scaling parameter temperature
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not 
-!--                 on ghost points. Hence, limit the indices. 
-                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                    j = MERGE( j           , nyn, j            > nyn )
-                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                    i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
@@ -1388,15 +2871,15 @@
                     ENDDO
                  ENDDO
-                 
-              CASE ( 'hfls' )
+
+              CASE ( 'hfls' ) ! surface latent heat flux
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not 
-!--                 on ghost points. Hence, limit the indices. 
-                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                    j = MERGE( j           , nyn, j            > nyn )
-                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                    i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
@@ -1412,15 +2895,15 @@
                     ENDDO
                  ENDDO
-                 
-              CASE ( 'hfss' )
+
+              CASE ( 'hfss' ) ! surface sensible heat flux
                  DO  m = 1, vmea(l)%ns
 !
-!--                 Surface data is only available on inner subdomains, not 
-!--                 on ghost points. Hence, limit the indices. 
-                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                    j = MERGE( j           , nyn, j            > nyn )
-                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                    i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
                     DO  mm = surf_def_h(0)%start_index(j,i),                   &
                              surf_def_h(0)%end_index(j,i)
@@ -1436,16 +2919,48 @@
                     ENDDO
                  ENDDO
-                 
-              CASE ( 'rnds' )
+
+              CASE ( 'hfdg' ) ! ground heat flux
+                 DO  m = 1, vmea(l)%ns
+!
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
+                    DO  mm = surf_lsm_h%start_index(j,i),                      &
+                             surf_lsm_h%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%ghf(mm)
+                    ENDDO
+                 ENDDO
+
+              CASE ( 'lwcs' )  ! liquid water of soil layer
+!                  DO  m = 1, vmea(l)%ns
+! !
+! !--                 Surface data is only available on inner subdomains, not
+! !--                 on ghost points. Hence, limit the indices.
+!                     j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+!                     j = MERGE( j           , nyn, j            < nyn )
+!                     i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+!                     i = MERGE( i           , nxr, i            < nxr )
+! 
+!                     DO  mm = surf_lsm_h%start_index(j,i),                      &
+!                              surf_lsm_h%end_index(j,i)
+!                        vmea(l)%measured_vars(m,n) = ?
+!                     ENDDO
+!                  ENDDO
+
+              CASE ( 'rnds' ) ! surface net radiation
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not 
-!--                    on ghost points. Hence, limit the indices. 
-                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                       j = MERGE( j           , nyn, j            > nyn )
-                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                       i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                    Surface data is only available on inner subdomains, not
+!--                    on ghost points. Hence, limit the indices.
+                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                       j = MERGE( j           , nyn, j            < nyn )
+                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                       i = MERGE( i           , nxr, i            < nxr )
+
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
@@ -1458,16 +2973,16 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'rsus' )
+
+              CASE ( 'rsus' ) ! surface shortwave out
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not 
-!--                    on ghost points. Hence, limit the indices. 
-                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                       j = MERGE( j           , nyn, j            > nyn )
-                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                       i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                    Surface data is only available on inner subdomains, not
+!--                    on ghost points. Hence, limit the indices.
+                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                       j = MERGE( j           , nyn, j            < nyn )
+                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                       i = MERGE( i           , nxr, i            < nxr )
+
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
@@ -1480,16 +2995,16 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'rsds' )
+
+              CASE ( 'rsds' ) ! surface shortwave in
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not 
-!--                    on ghost points. Hence, limit the indices. 
-                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                       j = MERGE( j           , nyn, j            > nyn )
-                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                       i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                    Surface data is only available on inner subdomains, not
+!--                    on ghost points. Hence, limit the indices.
+                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                       j = MERGE( j           , nyn, j            < nyn )
+                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                       i = MERGE( i           , nxr, i            < nxr )
+
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
@@ -1502,16 +3017,16 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'rlus' )
+
+              CASE ( 'rlus' ) ! surface longwave out
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not 
-!--                    on ghost points. Hence, limit the indices. 
-                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                       j = MERGE( j           , nyn, j            > nyn )
-                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                       i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                    Surface data is only available on inner subdomains, not
+!--                    on ghost points. Hence, limit the indices.
+                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                       j = MERGE( j           , nyn, j            < nyn )
+                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                       i = MERGE( i           , nxr, i            < nxr )
+
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
@@ -1524,16 +3039,16 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'rlds' )
+
+              CASE ( 'rlds' ) ! surface longwave in
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
 !
-!--                    Surface data is only available on inner subdomains, not 
-!--                    on ghost points. Hence, limit the indices. 
-                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) < nys )
-                       j = MERGE( j           , nyn, j            > nyn )
-                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) < nxl )
-                       i = MERGE( i           , nxr, i            > nxr )
-                    
+!--                    Surface data is only available on inner subdomains, not
+!--                    on ghost points. Hence, limit the indices.
+                       j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                       j = MERGE( j           , nyn, j            < nyn )
+                       i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                       i = MERGE( i           , nxr, i            < nxr )
+
                        DO  mm = surf_lsm_h%start_index(j,i),                   &
                                 surf_lsm_h%end_index(j,i)
